/*
   AppManager.h created by enoyau on Fri 13-Jan-1995

   You may freely copy, distribute, and reuse the code in this example.
   NeXT disclaims any warranty of any kind, expressed or implied, as to its
   fitness for any particular use.
*/
// AppManager is responsible for initializing the objects used in the
// program, such as DEONotificationCenter.
// AppManager communicates with EOF by being the delegate of EODatabaseChannel
// and EOAdaptorContext.

#import <appkit/appkit.h>
#import <eoaccess/eoaccess.h>
#import <eointerface/eointerface.h>

#import "DEONotificationCenter.h"
#import "DEONotification.h"

@interface AppManager : Object
{
    id eoController;
    id lockButton;
    id tableView;

    DEONotificationCenter *deoNotificationCenter;
    NSMutableArray *transactions;
    NSString *lockString; // Unique identifier made of username, hostname and pid
    BOOL needRedisplay; // YES - need to redisplay when user has finished editing. NO is default
       
}

- (void)databaseChange:(DEONotification *)notification;
- toggleLockOnSelection:sender;
@end

@interface AppManager(EOApplicationDelegate)
- appDidInit:sender;
- appWillTerminate:sender;
@end

@interface AppManager(EOControllerDelegate)
- (void)controllerDidChangeSelection:(EOController *)controller;
@end

@interface AppManager(EODatabaseChannelDelegate)
- (void)databaseChannel:channel didUpdateObject:anEO;
@end

@interface AppManager(EOAdaptorContextDelegate)
- (void)adaptorContextDidBegin:context;
- (void)adaptorContextDidCommit:context;
- (void)adaptorContextDidRollback:context;
@end
