/*
   DEOProtocols.h created by enoyau on Fri 13-Jan-1995

   You may freely copy, distribute, and reuse the code in this example.
   NeXT disclaims any warranty of any kind, expressed or implied, as to its
   fitness for any particular use.
*/
// Communication protocols between the DEONotificationCenter and the
// DEOServer.

#import <foundation/NSString.h>
#import <foundation/NSDictionary.h>

#define wantLog YES

#define DEOServerName "DEOServer"

@protocol DEOClient
- (oneway)dispatchInformation:(NSDictionary *)info
                       forKey:(NSString *)key
                     userInfo:(NSDictionary *)userInfo;
@end

@protocol DEOServer <DEOClient>
- (oneway)registerClient:(id <DEOClient>)client forKey:(NSString *)key;
- (oneway)unregisterClient:(id <DEOClient>)client forKey:(NSString *)key;
- (oneway)unregisterClient:(id <DEOClient>)client;
@end
