/*--------------------------------------------------------------------------
 *
 * 	You may freely copy, distribute, and reuse the code in this example.
 * 	SHL Systemhouse disclaims any warranty of any kind, expressed or  
 *	implied, as to its fitness for any particular use.
 *
 *	Catalog
 *
 *	Inherits From:		NSObject
 *
 *	Conforms To:		None
 *
 *	Declared In:		Catalog.h
 *
 *	Class Description
 *
 *		Contains author information with titles and publishing information.
 *		Demonstrates the KeyValueCoding protocol.
 *
 *------------------------------------------------------------------------*/
#import <appkit/appkit.h>
#import <eointerface/eointerface.h>
#import <eoaccess/eoaccess.h>
#import <foundation/NSObject.h>
#import <foundation/NSArray.h>
#import <foundation/NSDictionary.h>	

@interface Catalog:NSObject
{
    id	fullname;
    id	price;
    id	volumeTitle;
}

/*--------------------------------------------------------------------------
 *	Accessor methods
 *------------------------------------------------------------------------*/
- authorName;
- volumeTitle;
- price;

- setPrice: aPrice;


/*--------------------------------------------------------------------------
 *	Key Value Coding protocol
 *------------------------------------------------------------------------*/
- (BOOL)takeValuesFromDictionary:(NSDictionary *)dictionary;
- (NSDictionary *)valuesForKeys:(NSArray *)keys;


@end
