/* SybaseDelegate.h:
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or  implied, as to its
 * fitness for any particular use.
 *
 * 
 *
 */


#import <eoaccess/eoaccess.h>
#import <appkit/appkit.h>
#import <foundation/NSArray.h>
#import <foundation/NSObject.h>
#import <foundation/NSDictionary.h>

@class SybaseChannel;

typedef enum
{
    SybaseRegularRow,
    SybaseComputeRow,
    SybaseReturnParameterRow,
    SybaseReturnStatusRow
} SybaseRowType;

@interface SybaseDelegate:NSObject
{
	SybaseRowType	currentRowType;
}

- (SybaseRowType) currentRowType;

- (NSArray *)sybaseChannel:(SybaseChannel *)channel
    willFetchAttributes:(NSArray *)attributes
    forRowOfType:(SybaseRowType)rowType
    withComputeRowId:(int)computeRowId;

- (BOOL)sybaseChannel:(SybaseChannel *)channel
    willReturnRow:(NSDictionary *)row ofType:(SybaseRowType)rowType 
    withComputeRowId:(int)computeRowId;
	
- (void)adaptorChannelDidChangeResultSet:channel;
- (void)adaptorChannel:channel
    didEvaluateExpression:(NSString *)expression;
@end