/*
**      NXTableProtocols.h
**      Copyright (c) 1992, NeXT Computer, Inc.  All rights reserved. 
*/
#import <appkit/appkit.h>

/*
 *  This protocol is used to parameterize rows and columns in a table.
 */
@protocol NXTableVectors
- formatter;
- setFormatter:newFormatter;
- (BOOL) isResizable;
- setResizable:(BOOL) isResizable;
- (BOOL) isAutosizable;
- setAutosizable:(BOOL) isAutosizable;
- (BOOL) isEditable;
- setEditable:(BOOL) isEditable;
- (NXCoord) minSize;
- setMinSize:(NXCoord) newMinSize;
- (NXCoord) maxSize;
- setMaxSize:(NXCoord) newMaxSize;
- (NXCoord) size;
- (NXCoord) sizeTo:(NXCoord) newSize;
- (const char *) title;
- setTitle:(const char *) title;
- titleFont;
- setTitleFont:aFont;
-  identifier;
- setIdentifier:anIdentifier;
- (int) titleAlignment;
- setTitleAlignment:(int) align;
- (int) contentAlignment;
- setContentAlignment:(int) align;
@end


@interface Object(NXTableDataSources)
- (unsigned int) rowCount;
- (unsigned int) columnCount;

- getValueFor:identifier at:(unsigned int) aPosition into:aValue;
- setValueFor:identifier at:(unsigned int) aPosition from:aValue;

- getValueFor:rowIdentifier :columnIdentifier into:aValue;
- setValueFor:rowIdentifier :columnIdentifier from:aValue;
@end


@protocol NXTableValue

- (const char *)objCType;

- setNull;
- (BOOL)isNull;

- objectValue;
- (int)intValue;
- (float)floatValue;
- (double)doubleValue;
- (const char *)stringValue;
- string;

- setObjectValue:(id)anObject;
- setIntValue:(int)anInt;
- setFloatValue:(float)aFloat;
- setDoubleValue:(double)aDouble;
- setStringValue:(const char *)aString;

- setObjectValueNoCopy:(id)anObject;
- setStringValueNoCopy:(const char *)aString;
- (void)setString: aString;

@end

